HDU 5791 Two

Two

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)
Total Submission(s): 2692    Accepted Submission(s): 1156


Problem Description
Alice gets two sequences A and B. A easy problem comes. How many pair of sequence A' and sequence B' are same. For example, {1,2} and {1,2} are same. {1,2,4} and {1,4,2} are not same. A' is a subsequence of A. B' is a subsequence of B. The subsequnce can be not continuous. For example, {1,1,2} has 7 subsequences {1},{1},{2},{1,1},{1,2},{1,2},{1,1,2}. The answer can be very large. Output the answer mod 1000000007.
 

Input
The input contains multiple test cases.

For each test case, the first line cantains two integers  N,M(1N,M1000). The next line contains N integers. The next line followed M integers. All integers are between 1 and 1000.
 

Output
For each test case, output the answer mod 1000000007.
 

Sample Input
 
  
3 21 2 32 13 21 2 31 2
 

Sample Output
 
  
23

题意:给定两个数列。求出它们公共子序列的数量并对1e9+7取模

一开始没什么思路,后面看了大佬们的代码发现可以用dp做,emmm

切入正题,我们可以用dp[i][j]表示A序列到i位,B序列到j位相同子序列的个数

那么a[i]==b[j]的话

dp[i][j]=(dp[i-1][j]+d[i][j-1]+1)%mod;

不满足的话(这里要考虑防止相减得出负数的情况,所以加上mod)

dp[i][j]=(dp[i-1][j]+dp[i][j-1]-dp[i-1][j-1]+mod)%mod;

附上全部代码:

#include <iostream>
#include <cstdio>
#define mod 1000000007
using namespace std;
int a[1005],b[1005];
long long dp[1005][1005];
int main(){
    int n,m;
//    freopen("in.in","r",stdin);
    while(cin>>n>>m){
        dp[0][0]=dp[0][1]=dp[1][0]=0;
        for(int i=1;i<=n;i++)
            cin>>a[i];
        for(int i=1;i<=m;i++)
            cin>>b[i];
        for(int i=1;i<=n;i++){
            for(int j=1;j<=m;j++){
                if(a[i]==b[j]){
                    dp[i][j]=(dp[i-1][j]+dp[i][j-1]+1)%mod;
                }
                else{
                    dp[i][j]=(dp[i-1][j]+dp[i][j-1]-dp[i-1][j-1]+mod)%mod;
                }
            }
        }
        cout<<dp[n][m]<<endl;
    }
}

猜你喜欢

转载自blog.csdn.net/coderdogg/article/details/80344938
two